-- Registering with AceAddon
ArenaReply = LibStub("AceAddon-3.0"):NewAddon("ArenaReply", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
ArenaReply.whisperlist = {}

function ArenaReply:OnEnable()
	self:RegisterEvent("CHAT_MSG_WHISPER");
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
end

local function DelayExpired(author)
	ArenaReply.whisperlist[author] = false;
end

function ArenaReply:CHAT_MSG_BG_SYSTEM_NEUTRAL(event, msg)
	local inarena;
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local status, map2, _, _, _, size, rated = GetBattlefieldStatus(i);
		if status == "active" and (size == 2 or size == 3 or size == 5) then
			inarena = true;
			break
		end
	end
	if string.match(msg, "has begun") and inarena then
		ArenaReply.battleunderway = true;
	end
end

function ArenaReply:PLAYER_ENTERING_WORLD()
	local inarena;
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local status, map2, _, _, _, size, rated = GetBattlefieldStatus(i);
		if status == "active" and (size == 2 or size == 3 or size == 5) then
			inarena = true;
			break
		end
	end
	if not ArenaReply.battleunderway or not inarena then
		ArenaReply.battleunderway = false;
	else
		ArenaReply.battleunderway = true;
	end
end

function ArenaReply:CHAT_MSG_WHISPER(event, message, author)
	local type = "skirmish";
	local arenasize
	local map
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local status, map2, _, _, _, size, rated = GetBattlefieldStatus(i);
		if status == "active" and (size == 2 or size == 3 or size == 5) then
			arenasize = size;
			map = map2;
			if rated then
				type = "rated";
			end
			break;
		end
	end
	if arenasize ~= 2 and arenasize ~=3 and arenasize ~=5 then
		return
	end
	if not ArenaReply.whisperlist[author] or message ==	"status" then
		SendChatMessage("[ArenaReply] "..UnitName("player").." is currently fighting a "..arenasize.."v"..arenasize.." "..type.." arena match on "..map..".", "WHISPER", nil, author);
		if not ArenaReply.battleunderway then
			SendChatMessage("The battle is currently in the preparation phase.", "WHISPER", nil, author);
			ArenaReply.whisperlist[author] = true;
			ArenaReply:ScheduleTimer(DelayExpired, 15, author);
			return
		end
		local msg;
		if arenasize < 5 then
			msg = "["..UnitName("player").."'s team]: "..UnitName("player")..": "..UnitHealth("player").."/"..UnitHealthMax("player").." ("..(math.floor((UnitHealth("player")/(UnitHealthMax("player")/100))*10)/10).."%)";
			for i=1, (arenasize-1) do
				msg = msg.."  "..UnitName("party"..i)..": "..UnitHealth("party"..i).."/"..UnitHealthMax("party"..i).." ("..(math.floor((UnitHealth("party"..i)/(UnitHealthMax("party"..i)/100))*10)/10).."%)";
			end
		else
			msg = "["..UnitName("player").."'s team]: "..UnitName("player")..": "..(math.floor((UnitHealth("player")/(UnitHealthMax("player")/100))*10)/10).."%";
			for i=1, (arenasize-1) do
				msg = msg.."  "..UnitName("party"..i)..": "..(math.floor((UnitHealth("party"..i)/(UnitHealthMax("player")/100))*10)/10).."%";
			end
		end
		SendChatMessage(msg, "WHISPER", nil, author);
		local enemymsg;
		msg = "[Enemy team]: ";
		for e=1, arenasize do
			if e ~= 1 then
				msg = msg.."  ";
			end
			if arenasize < 5 then
				if not UnitName("arena"..e) or UnitHealthMax("arena"..e) == 0 then
					msg = msg.."Enemy "..e..": n/a";
				else
					msg = msg..UnitName("arena"..e)..": "..UnitHealth("arena"..e).."/"..UnitHealthMax("arena"..e).." ("..(math.floor((UnitHealth("arena"..e)/(UnitHealthMax("arena"..e)/100))*10)/10).."%)";
				end
			else
				if not UnitName("arena"..e) then
					msg = msg.."Enemy "..e..": n/a";
				else
					msg = msg..UnitName("arena"..e)..": "..(math.floor((UnitHealth("arena"..e)/(UnitHealthMax("arena"..e)/100))*10)/10).."%";
				end
			end
		end
		SendChatMessage(msg, "WHISPER", nil, author);
		ArenaReply.whisperlist[author] = true;
		ArenaReply:ScheduleTimer(DelayExpired, 15, author);
	end
end

function ArenaReply:Test()
	ArenaReply:CHAT_MSG_WHISPER("CHAT_MSG_WHISPER", "status", UnitName("player"));
end

function ArenaReply:OnInitialize()
	self:RegisterChatCommand("arenareply",		"Test");
end

function ArenaReply:ChatFilter(event, msg, author, ...)
	local a = string.match(msg, "%[ArenaReply%]");
	if a then
		return true;
	else
		return false, msg, author, ...;
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", ArenaReply.ChatFilter);
